  { Turbo Sort }
  { Copyright (c) 1985,90 by Borland International, Inc. }
  Program qsort;
  {$R-,S-}
  { This program demonstrates the quicksort algorithm, which      }
  { provides an extremely efficient method of sorting arrays in   }
  { memory. The program generates a list of 1000 random numbers   }
  { between 0 and 29999, and then sorts them using the QUICKSORT  }
  { procedure. Finally, the sorted list is output on the screen.  }
  { Note that stack and range checks are turned off (through the  }
  { compiler directive above) to optimize execution speed.        }
  Const
    max = 100;
  Type
    list = array[1..max] of integer;
  Var
    data: list;
    i: integer;
  { QUICKSORT sorts elements in the array A with indices between  }
  { LO and HI (both inclusive). Note that the QUICKSORT proce-    }
  { dure provides only an "interface" to the program. The actual  }
  { processing takes place in the SORT procedure, which executes  }
  { itself recursively.                                           }
  Procedure quicksort(Var a: list;
    Lo,Hi: integer);
  Procedure sort(l,r: integer);
  Var
    i,j,x,y: integer;
  Begin
    i:=l;
    j:=r;
    x:=a[(l+r) div 2];
    Repeat
      While a[i]<x do
        i:=i+1;
      While x<a[j] do
        j:=j-1;
      If i<=j then
        Begin
          y:=a[i];
          a[i]:=a[j];
          a[j]:=y;
          i:=i+1;
          j:=j-1;
        end;
    until i>j;
  If l<j then
    sort(l,j);
  If i<r then
    sort(i,r);
  end;
  Begin
  {quicksort};
    sort(Lo,Hi);
  end;
  Begin
  {qsort}
    Write('Now generating 100 random numbers...');
    For i:=1 to max do
      data[i]:=random(30000);
    WriteLn;
    WriteLn('Now sorting random numbers...');
    quicksort(data,1,max);
    WriteLn;
    For i:=1 to max do
      WriteLn(data[i]:8);
  end.
